<p-confirmDialog></p-confirmDialog>

<p-dialog
  header="Sonderöffnungszeiten"
  [(visible)]="displayDialog"
  [modal]="true"
  [closable]="false"
  [focusOnShow]="false"
  [style]="{ width: '50vw' }"
>
  <div *ngIf="editableHours.length === 0" class="p-text-center">
    Keine Sonderöffnungszeiten verfügbar. Klicke auf "+" um neue hinzuzufügen.
  </div>

  <p-accordion
    *ngIf="editableHours.length > 0"
    [multiple]="true"
    [activeIndex]="activeAccordionIndex"
  >
    <p-accordionTab
      *ngFor="let hour of editableHours; let i = index"
      [header]="
        hour.date ? (hour.date | date : 'dd.MM.yyyy') ?? '' : 'Neuer Eintrag'
      "
    >
      <div class="entry-container">
        <div class="entry-row checkbox-column">
          <div class="checkbox-item">
            <input
              type="checkbox"
              [(ngModel)]="hour.allDay"
              (change)="handleAllDayChange(hour)"
              id="allDay-{{ i }}"
            />
            <label [for]="'allDay-' + i">Ganztägig geöffnet</label>
          </div>
          <div class="checkbox-item">
            <input
              type="checkbox"
              [(ngModel)]="hour.closed"
              (change)="handleClosedChange(hour)"
              id="closed-{{ i }}"
            />
            <label [for]="'closed-' + i">Geschlossen</label>
          </div>
        </div>
        <div class="entry-row">
          <div class="field">
            <div>Datum</div>
            <p-calendar
              [(ngModel)]="hour.date"
              dateFormat="dd.mm.yy"
              placeholder="Datum wählen"
              [showIcon]="false"
              [minDate]="today"
              appendTo="body"
            ></p-calendar>
          </div>

          <div class="field" *ngIf="!hour.closed && !hour.allDay">
            <div>Von</div>
            <p-calendar
              [(ngModel)]="hour.from"
              timeOnly="true"
              hourFormat="24"
              placeholder="Von"
              appendTo="body"
              (onSelect)="handleFromTimeSelect(hour)"
            ></p-calendar>
          </div>

          <div class="field" *ngIf="!hour.closed && !hour.allDay">
            <div>Bis</div>
            <p-calendar
              [(ngModel)]="hour.to"
              timeOnly="true"
              hourFormat="24"
              placeholder="Bis"
              appendTo="body"
            ></p-calendar>
          </div>
        </div>

        <div class="entry-row">
          <div class="field">
            <div>Beschreibung (Deutsch)</div>
            <input
              pInputText
              [(ngModel)]="hour.descriptionDe"
              placeholder="Beschreibung auf Deutsch"
            />
          </div>

          <div class="field">
            <div>Beschreibung (Englisch)</div>
            <input
              pInputText
              [(ngModel)]="hour.descriptionEn"
              placeholder="Beschreibung auf Englisch"
            />
          </div>
        </div>

        <div class="justify-content-end flex">
          <p-button
            *urboCmsUiHasPermission="Permission.ParkingAreaWrite"
            label="Löschen"
            icon="pi pi-trash"
            class="mr-2"
            severity="danger"
            pTooltip="Eintrag entfernen"
            (click)="confirmRemoveOpeningHour(i)"
          ></p-button>
        </div>
      </div>
    </p-accordionTab>
  </p-accordion>

  <div class="button-container">
    <button
      pButton
      icon="pi pi-plus"
      class="p-button-rounded p-button-success p-button-sm add-button plus-button"
      pTooltip="Neue Öffnungszeit hinzufügen"
      (click)="addNewOpeningHour()"
    ></button>
  </div>

  <div *ngIf="errorMessage" class="p-error" style="margin-top: 1rem">
    {{ errorMessage }}
  </div>

  <p-footer>
    <button
      pButton
      type="button"
      label="Abbrechen"
      icon="pi pi-times"
      class="p-button-text"
      (click)="cancel()"
    ></button>
    <button
      pButton
      type="button"
      label="Speichern"
      icon="pi pi-check"
      (click)="saveChanges()"
    ></button>
  </p-footer>
</p-dialog>
